import pygame, sys
from constants import *
from game import *
from characters import *
from things import *
from Queue import Queue

def opposite_dir(d):
    if d == 'u': return 'd'
    elif d == 'd': return 'u'
    elif d == 'l': return 'l'
    elif d == 'r': return 'r'

def xy2tile(xy):
    x,y = xy
    return (y//TILESIZE, x//TILESIZE)

def tile_center(tile):
    return (tile[1] * TILESIZE + TILESIZE//2, tile[0] * TILESIZE + TILESIZE//2)

def tile2xy(tile):
    r,c = tile
    return (c * TILESIZE + TILESIZE/2, r * TILESIZE + TILESIZE/2)

def d2tile(d, (r,c)):
    if d == 'u':
        return (r-1,c)
    elif d == 'd':
        return (r+1,c)
    elif d == 'l':
        return (r,c-1)
    elif d == 'r':
        return (r,c+1)

def d2xy(d, startxy, speed):
    if d == 'u':
        return (startxy[0],startxy[1]-speed)
    if d == 'd':
        return (startxy[0],startxy[1]+speed)
    if d == 'l':
        return (startxy[0]-speed,startxy[1])
    if d == 'r':
        return (startxy[0]+speed,startxy[1])

def bfs_short_path(start, end, eligible):
    explored = [start]
    directions = ['x']
    dists = {start:0}
    predecessors = {}
    q = Queue()
    q.put(start)

    while q.qsize():
        sr, sc = q.get()
        up = ((sr-1, sc), 'u')
        down = ((sr+1, sc), 'd')
        left = ((sr, sc-1), 'l')
        right = ((sr, sc+1), 'r')
        for d in (up, down, left, right):
            if d[0] in eligible and d[0] not in explored:
                q.put(d[0])
                explored.append(d[0])
                directions.append(d[1])
                dists[d[0]] = dists[(sr, sc)] + 1 
                predecessors[d[0]] = ((sr, sc), d[1])

    shortpath = []
    retrace = end 
    while retrace != start:
        try:
            shortpath.append(predecessors[retrace][1])
            retrace = predecessors[retrace][0]
        except:
            return []
    shortpath.reverse()
    return shortpath


