from constants import *
import pygame, time, sys
from pygame.locals import *


def show_intro():
    title = "MISCHIEF MOON"
    startover = "Press 1 to start over from level 1."
    
    WINDOW.blit(BACKGROUND, (0,0))
    WINDOW.blit(SPACEMANBIG, (50,50))

    text = pygame.font.Font('freesansbold.ttf', 48)
    surf = text.render(title, True, cINTROTEXT)
    WINDOW.blit(surf, (WINSIZE[0]/2 - surf.get_width()/2 + 80, WINSIZE[1]/4))

    surf = text.render("Press SPACE to start,", True, cINTROTEXT)
    WINDOW.blit(surf, (270,370))
    surf = text.render("or ALT to play custom levels.", True, cINTROTEXT)
    WINDOW.blit(surf, (270,430))

    if os.path.exists(OUTFILENAME):
        surf = text.render(startover, True, cINTROTEXT)
        WINDOW.blit(surf, (WINSIZE[0]/2 - surf.get_width()/2, 580))
        o = open(OUTFILENAME)
        savedlevel = int(o.read())
    else:
        savedlevel = 1

    pygame.display.update()

    while True:
        if pygame.key.get_pressed()[K_SPACE]:
            return savedlevel
        if pygame.key.get_pressed()[K_1]:
            return 1
        if pygame.key.get_pressed()[K_LALT] or pygame.key.get_pressed()[K_RALT]:
            return 'c'
        if pygame.key.get_pressed()[K_ESCAPE]:
            pygame.quit()
            sys.exit()
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
        time.sleep(0.1)

def show_ending():
    WINDOW.blit(BACKGROUND, (0,0))
    WINDOW.blit(SPACEMANBIG, (500,50))


    text = pygame.font.Font('freesansbold.ttf', 48)
    surf = text.render("YOU WIN!", True, cINTROTEXT)
    WINDOW.blit(surf, (100, 300))

    pygame.display.update()
    time.sleep(1)

    pygame.mixer.music.load(os.path.join('sound','winmusic.ogg'))
    pygame.mixer.music.play(1)

    while True:
        if pygame.key.get_pressed()[K_ESCAPE]:
            pygame.quit()
            sys.exit()
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
        time.sleep(0.1)
